var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var matchers = [];
var getNameOf = function (type) {
    if (!type)
        return 'Unknown';
    if (typeof type === 'string')
        return type;
    return type.displayName || type.name || 'Component';
};
var realAddMock = function (mock) { return matchers.push(mock); };
var MockedOut = function () { return null; };
var MockedTransparent = function (_a) {
    var children = _a.children;
    return children;
};
var defaultMock = function (type, props) { return ({
    type: MockedOut,
    props: __assign({ itWas: getNameOf(type) }, props)
}); };
var mock = function (type, mockBy) {
    var mock = {
        test: function (element) {
            var elementName = getNameOf(element);
            return element === type ||
                (typeof type !== 'function' && (elementName === type ||
                    (typeof type !== "string" && !!elementName.match(type))));
        },
        replace: mockBy || defaultMock
    };
    return realAddMock(mock);
};
var match = function (match, mockBy) {
    var mock = {
        test: match,
        replace: mockBy || defaultMock
    };
    return realAddMock(mock);
};
var transparent = function (type) {
    return mock(type, function () { return ({ type: MockedTransparent }); });
};
var renderProp = function (type) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return mock(type, function (type, props, _children) {
        var children = Array.isArray(_children) ? _children[0] : _children;
        if (typeof children !== "function") {
            console.error('remock: mocked', type, ' expects', children, ' to be a function (it is ', typeof children, ')');
            return {};
        }
        return {
            type: MockedTransparent,
            props: { itWas: type }, children: children.apply(void 0, args)
        };
    });
};
var unmock = function (type, props) {
    matchers = matchers.filter(function (mock) { return !mock.test(type, props); });
};
var clearMocks = function () {
    matchers = [];
};
var getMocks = function () { return matchers; };
export { mock, match, unmock, transparent, renderProp, clearMocks, getMocks };
