/// <reference types="react" />
import * as React from 'react';
export declare type AnyElement = string | React.ComponentType<any>;
export declare type ElementMatcher = AnyElement | RegExp;
export declare type Matcher = (type: ElementMatcher, props: any, children?: any[]) => boolean;
export declare type Mocker = (type: AnyElement, props?: any, children?: any[]) => {
    type?: AnyElement;
    props?: any;
    children?: any[];
};
export interface Mock {
    test: Matcher;
    replace: Mocker;
}
declare const mock: (type: ElementMatcher, mockBy?: Mocker) => number;
declare const match: (match: Matcher, mockBy?: Mocker) => number;
declare const transparent: (type: ElementMatcher) => number;
declare const renderProp: (type: ElementMatcher, ...args: any[]) => number;
declare const unmock: (type: AnyElement, props?: any) => void;
declare const clearMocks: () => void;
declare const getMocks: () => Mock[];
export { mock, match, unmock, transparent, renderProp, clearMocks, getMocks };
